#!/usr/bin/python3

"""
Etsii syötteestä paramterit, ja loogiset operaattorit Esim.
getparam("hmm&&'kkkkökkötraktori||hmm2'||Vielä Uusi parametri^(Mielenkiintoista Eikö vain? && Onhan tämä)")
Palauttaa seuraavat:
                                           P0                   P1                                     P2                                   P3                              P4
('P0&P1|P2^{P3&P4}',["hmm",'kkkkökkötraktori||hmm2','Vielä Uusi parametri','Mielenkiintoista Eikö vain?','Onhan tämä'])

Käyttöohje:
Lisää kaikki sanat self.addSearchWord-metodilla kokonaisuudessaan nodeihin
Sen jälkeen trimmaa trimNodes-metodilla hakusanat, jotta turhat valinnat lähtevät pois.

"""

#import searchNode
import sys

debug = True
debug = False
class SolveFormulaParams:
    def __init__(self,params:str):
        self.params=[]  # Palautettavat paramterit
        # Esimerkissä:["hmm",'kkkkökkötraktori||hmm2','Vielä Uusi parametri','Mielenkiintoista Eikö vain?','Onhan tämä']
        self.function="" # Palauttaa kaavan Esimerkissä: 'P0&P1|P2^{P3&P4}'
        #self.differentChars=len(searchstr)+1
        (self.function,self.params)=self.solveParams(params+"&")
        if self.function!="":
            self.function=self.function[:-1]
        if debug:
            print(self.function,"prms=",self.params)
        if self.checkFormula(self.function):
            if debug:
                print("Formula Ok!")

    def nxtch(self,idx,prm):
        if len(prm)>idx:
            return prm[idx]
        return ""

    def checkFormula(self,fnc:str):
        xfnc:str=""
        attributeNro=0
        while xfnc!=fnc:
            xfnc=fnc
            fnc=fnc.replace(" P"+str(attributeNro)+" ","?")
            attributeNro+=1
        xfnc=""
        while xfnc!=fnc:
            xfnc=fnc
            fnc=fnc.replace("~?","?")
            fnc=fnc.replace("?|?","?")
            fnc=fnc.replace("?&?","?")
            fnc=fnc.replace("?^?","?")
            fnc=fnc.replace("(?)","?")
        if debug:
            print("fnc=",fnc)
        return fnc=="?"
        #xfnc=""
        #while xfnc!=fnc:

        print(fnc)
        #quit()

    # KORJAA TÄMÄ REKURSIIVINEN BUGIKASA
    def solveFst(fnc,parent):
        #if fnc
        #if end==-1:
        #    end=len(fnc)
        xfnc=""
        while xfnc!=fnc:
            xfnc=fnc
            fnc=fnc.replace("~~","")
        if debug:
            print("parent:",parent,",solveFst(",fnc,")")
        try:
            error=fnc.index("E")
            return "E"
        except:
            pass
        #print("parent=",parent)
        if fnc=="T" or fnc=="F" or fnc=="E":#T->True, F->False, E-> Error
            return fnc
        try:
                #print(fnc)
                middleStart=fnc.rindex("(")
                #print(fnc)
                middleEnd=fnc.index(")",middleStart)
                #print(fnc)
                #print("st=",middleStart,"end=",middleEnd)
                st=""
                ed=""
                head=""
                tail=""
                middle=""
                if middleStart>0:
                    head=fnc[:middleStart]
                    #st=fnc[:middleStart]
                if middleEnd>middleStart:
                    #ed=fnc[middleEnd:-1]
                    tail=fnc[middleEnd+1:]
                if middleEnd>middleStart and middleStart>=0:
                    middle=fnc[middleStart+1:middleEnd]
                #if middle!="" and head!="" and tail!="":
                #print("fnc=",fnc,"st=",st,"ed=",ed,"tail=",tail,"head=",head,"middle=",middle)
                if debug:
                    print("new=",head+middle+tail)
                #quit()
                #if head!="":
                #    tmpresHead=SolveFormulaParams.solveFst(head)
                if debug:
                    print("middle=",middle)
                tmpresMiddle=SolveFormulaParams.solveFst(middle,fnc)
                #tmpresTail=SolveFormulaParams.solveFst(tail)
                if debug:
                    print("solvedMiddle=",tmpresMiddle)
                    print(head,tmpresMiddle,tail)
                #quit()
                return SolveFormulaParams.solveFst(head+tmpresMiddle+tail,fnc)

                #print("fnc=",fnc,"st=",st,"ed=",ed,"tail=",tail,"head=",head,"middle=",middle)
                #quit()
        except:
                if debug:
                    print ("Tuli except:ioon")
                #quit()
                pass
        xfnc=fnc
        fnc=fnc.replace("~T","F")
        fnc=fnc.replace("~F","T")
        xfc=""
        while xfc!=fnc:
            xfc=fnc
            fnc=fnc.replace("&T","")
            fnc=fnc.replace("T&","")
            fnc=fnc.replace("F&F","F")
            fnc=fnc.replace("T&T","T")
        xfc=""
        while xfc!=fnc:
            xfc=fnc
            fnc=fnc.replace("T^T","F")
            fnc=fnc.replace("T^F","T")
            fnc=fnc.replace("F^T","T")
            fnc=fnc.replace("F^F","F")
        xfc=""
        while xfc!=fnc:
            xfc=fnc
            fnc=fnc.replace("T|T","T")
            fnc=fnc.replace("F|","")
            fnc=fnc.replace("|F","")
        if fnc!=fnc.replace("~","") or fnc!=fnc.replace("&","") or fnc!=fnc.replace("^","") or fnc!=fnc.replace("|",""):
            return "E"
        return fnc

    def solveFormula(self,fnc:str="",values:str=""):
        if fnc=="":
            fnc=self.function
        if not self.checkFormula(fnc):
            return -1#Vääränlainen kaava, joten herjataan -1:llä
        attributeNro=0
        #print("Funktio=",fnc,
        values=values.replace("1","T")
        values=values.replace("0","F")
        for idx in range(len(values)):
            fnc=fnc.replace(" P"+str(idx)+" ",values[idx])
        if debug:
            print(fnc)
        xfnc="1"
        fnc=SolveFormulaParams.solveFst(fnc,"root:")
        """
        while xfnc!=fnc:
            xfnc=fnc
            #fnc=fnc.replace("(T)","T")
            #fnc=fnc.replace("(F)","F")
            #fnc=fnc.replace("(F|F)","F")
            #fnc=fnc.replace("(T|F)","T")
            #fnc=fnc.replace("
            #fnc=fnc.replace("~F","T")
            #fnc=fnc.replace("~T","F")
            #fnc=fnc.replace("T&T","T")
        """
        return fnc

    def fixSolveParamsResult(self,res:str):
        if len(res)==2:
            if res[0]=='\\':
                return res[1:]
        elif len(res)==1:
            if res[0]=='\\':
                print("Function ends '\\'-char",file=sys.stderr);
                return "\\"
            else:
                return res

        idx=0
        newres=""
        while idx<len(res): # Tässä silmukassa poistetaan alkutyhjät.
            if res[idx]>' ':
                break
            idx+=1
        # Tässä silmukassa poistetaan lopputyhjät s.e. jätetään '\':n jälkeinen merkki.
        lenres=len(res)-1
        while lenres>0:
            if res[lenres]=='\\':
                lenres+=2
                if debug:
                    print("Tuli =\\",res,len(res),lenres)
                break
            if res[lenres]>' ':
                lenres+=2
                if lenres+1>len(res):
                    lenres-=1
                break
            lenres-=1
        # Tässä silmukassa ratkaistaan varsinainen parametri.
        if debug:
            print(len(res),"res=",res)
            print(idx,lenres)
        #lenres-=1
        while idx<=lenres:
            if idx<len(res):
                if res[idx]=='\\':
                    idx+=1
                #if idx<len(res):
                if idx<lenres:
                    newres+=res[idx]
            idx+=1
        return newres

    def solveParams(self,params:str):
        res=""
        mode=0
        level=0
        idx=0
        ch="a"
        prms=[]
        fnc=""
        close=""
        paramscnt=0
        while idx<len(params) and ch!="":
            ch=self.nxtch(idx,params)
            if debug:
                print("ch=",ch,ord(ch))
            if mode==0:
                if debug:
                    print("mode=",mode)
                if ch=='\\':
                    res+=ch # Lisätty 20240123
                    idx+=1
                    ch=self.nxtch(idx,params)
                    res+=ch
                # Hipsujen määrittelemät parametrit.
                elif ch=='"' or ch=="'":
                    endch=ch
                    mode=1
                    idx+=1
                    ch=self.nxtch(idx,params)
                    if ch==endch:
                        res+='\\' # Lisätty 20240123
                        res+=ch
                    while ch!=endch and ch!="":
                        idx+=1
                        res+='\\' # Lisätty 20240123
                        res+=ch
                        ch=self.nxtch(idx,params)
                    mode=0
                    if ch=="":
                        print("Lainausmerkki/hipsu ilman loppua:",endch)
                        print("getparameter.py rivi n. 258")
                        quit()
                elif ch=='&' or ch=="|" or ch=="^":
                    kndch=ch
                    #if ch!="^":
                    #    idx+=1
                    #    ch=self.nxtch(idx,params)
                    #if debug:
                    #    print("Tuli!",kndch)
                    #if ch!=kndch:
                    #    print("Valitettavasti myös tänne:",ch)
                    #    res+=kndch
                    #    res+=ch
                    #else:
                    if True:
                        if debug:
                            print("JES TULI OIKEIN")
                        index=0
                        #res=res.strip() # Lisätty 20240122 Kommentoitu 20240123
                        if debug:
                            print("RES='"+res+"'")
                        res=self.fixSolveParamsResult(res) # Lisätty 20240123
                        if debug:
                            print("RES2='"+res+"'")
                        while index<len(prms):
                            if prms[index]==res:
                                break
                            index+=1
                        if index>=len(prms):
                            prms.append(res)
                        #index=len(prms)
                        #fnc=fnc+"P"+str(len(prms))+close+kndch
                        fnc=fnc+" P"+str(index)+" "+close+kndch
                        #prms.append(res)
                        close=""
                        res=""
                elif ch=="(" or ch==")" or ch=="{" or ch=="}" or ch=="[" or ch=="]":
                    if ch=="(" or ch=="{" or ch=="[":
                        ch="("
                        fnc+=ch
                    else:
                        close+=")"
                elif ch=="~":
                    fnc+=ch
                else:
                    res+=ch
            idx+=1
        if debug:
            print("rivi 301: fnc=",fnc,prms)
        fnc=self.trimFnc(fnc)
        if debug:
            print("rivi 302: fnc=",fnc,prms)
        return (fnc,prms)

    def trimFnc(self,fnc:str):
        return fnc.replace("~~","")


if __name__=='__main__':
    if len(sys.argv)==1:
        print("Ohjeet testaukseen...")
        print("     jos on vain yksi parametri, niin se palauttaa T:n F:n tai E:n. T tarkoittaa totta, F tarkoittaa epätotta ja E tarkoittaa erroria.")
        print("     Esim...")
        print("     "+__file__+" ~(T&F)^F|T")
        print("     tulostaa... T:n")
        print()
        print("     Jos parametreja on kaksi, niin ensimmäinen on lauseke ja toinen on etsittävä teksti.");
        print("     Tulostaa T:n F:n tai E:n, jossa T tarkoittaa totta, F epätotta ja E erroria.")


    if len(sys.argv)>1:
        #print(sys.argv[1])
        if len(sys.argv)==2:
            res=SolveFormulaParams.solveFst(sys.argv[1],"ROOT:")
            print("E=Error, F=Epätosi ja T=Tosi")
            print("Result=",res)
        if len(sys.argv)>2:

            fnc=SolveFormulaParams(sys.argv[1])#,"ROOT:")
            print("Yritetään ratkaista!")
            print(fnc.solveFormula(fnc.function,sys.argv[2]))
            print(fnc.params,fnc.function)
            if len(fnc.params)>0:
                print("len(fnc.params[0])=",len(fnc.params[0]))
            """=[]  # Palautettavat paramterit
            # Esimerkissä:["hmm",'kkkkökkötraktori||hmm2','Vielä Uusi parametri','Mielenkiintoista Eikö vain?','Onhan tämä']
            self.function="" # Palauttaa kaavan Esimerkissä: 'P0&P1
            """
